class LetterA{
  Point3D[] vertices = new Point3D[96];
  float w, h, d;

  // Constructors
  // default constructor
  LetterA(){
  }

  // constructor 2
  LetterA(float w, float h, float d){
    this.w = w;
    this.h = h;
    this.d = d;
    //front bottom
    vertices[0] = new Point3D(w/2, h/2, d/16);
    vertices[1] = new Point3D(w/2, 0, d/16);
    vertices[2] = new Point3D(-w/2, 0, d/16);
    vertices[3] = new Point3D(-w/2,h/2, d/16);
    vertices[4] = new Point3D(-w/4,h/2, d/16);

    vertices[5] = new Point3D(-w/4, (2*h)/10, d/16);
    vertices[6] = new Point3D(w/4, (2*h)/10, d/16); 
    vertices[7] = new Point3D(w/4,h/2, d/16);
    vertices[8] = new Point3D(w/2,h/2, d/16);
    //front top
    vertices[9] = new Point3D(w/2, 0, d/16);
    vertices[10] = new Point3D(w/2, -h/2, d/16);
    vertices[11] = new Point3D(-w/2, -h/2 , d/16);
    vertices[12] = new Point3D(-w/2, 0, d/16);
    vertices[13] = new Point3D(-w/4, 0, d/16);

    vertices[14] = new Point3D(-w/4, -(3*h)/10, d/16);
    vertices[15] = new Point3D(w/4, -(3*h)/10, d/16);
    vertices[16] = new Point3D(w/4, 0, d/16);
    vertices[17] = new Point3D(w/2, 0, d/16);
    //left
    vertices[18] = new Point3D(w/2,-h/2, d/16);
    vertices[19] = new Point3D(w/2,-h/2, -d/16);
    vertices[20] = new Point3D(w/2,h/2,-d/16);
    vertices[21] = new Point3D(w/2,h/2, d/16);
    vertices[22] = new Point3D(w/2,-h/2,d/16);
    //right
    vertices[23] = new Point3D(-w/2,-h/2,d/16);
    vertices[24] = new Point3D(-w/2,-h/2,-d/16);
    vertices[25] = new Point3D(-w/2,h/2,-d/16);
    vertices[26] = new Point3D(-w/2,h/2,d/16);
    vertices[27] = new Point3D(-w/2,-h/2,d/16);
    //inner left top
    vertices[28] = new Point3D(w/4,-(3*h)/10,d/16);
    vertices[29] = new Point3D(w/4,-(3*h)/10,-d/16);
    vertices[30] = new Point3D(w/4, 0,-d/16);
    vertices[31] = new Point3D(w/4, 0, d/16);
    vertices[32] = new Point3D(w/4,-(3*h)/10,d/16);
    //inner right top
    vertices[33] = new Point3D(-w/4,-(3*h)/10,d/16);
    vertices[34] = new Point3D(-w/4,-(3*h)/10,-d/16);
    vertices[35] = new Point3D(-w/4, 0,-d/16);
    vertices[36] = new Point3D(-w/4, 0, d/16);
    vertices[37] = new Point3D(-w/4,-(3*h)/10,d/16);
    //inner left bottom
    vertices[38] = new Point3D(w/4,h/2,d/16);
    vertices[39] = new Point3D(-w/4,(2*h)/10,d/16);
    vertices[40] = new Point3D(-w/4,(2*h)/10,-d/16);
    vertices[41] = new Point3D(w/4, -h/2, -d/16);
    vertices[42] = new Point3D(w/4,h/2,d/16);
    //inner right bottom
    vertices[43] = new Point3D(-w/4,h/2,d/16);
    vertices[44] = new Point3D(-w/4,-(2*h)/10,d/16);
    vertices[45] = new Point3D(-w/4,-(2*h)/10,-d/16);
    vertices[46] = new Point3D(-w/4, h/2, -d/16);
    vertices[47] = new Point3D(-w/4,h/2,d/16);
    //foot left bottom
    vertices[48] = new Point3D(w/2,h/2,d/16);
    vertices[49] = new Point3D(w/2,h/2,-d/16);
    vertices[50] = new Point3D(w/4, h/2,-d/16);
    vertices[51] = new Point3D(w/4, h/2, d/16);
    vertices[52] = new Point3D(w/2,h/2,d/16);
    //foot left bottom
    vertices[53] = new Point3D(-w/2,h/2,d/16);
    vertices[54] = new Point3D(-w/2,h/2,-d/16);
    vertices[55] = new Point3D(-w/4, h/2,-d/16);
    vertices[56] = new Point3D(-w/4, h/2, d/16);
    vertices[57] = new Point3D(-w/2,h/2,d/16);
    //bottom
    vertices[58] = new Point3D(w/4,(2*h)/10, d/16);
    vertices[59] = new Point3D(w/4,(2*h)/10, -d/16);
    vertices[60] = new Point3D(-w/4, (2*h)/10, -d/16);
    vertices[61] = new Point3D(-w/4, (2*h)/10, d/16);
    vertices[62] = new Point3D(w/4,(2*h)/10, d/16);
    //inner bottom
    vertices[63] = new Point3D(w/4, 0, d/16);
    vertices[64] = new Point3D(w/4, 0, -d/16);
    vertices[65] = new Point3D(-w/4, 0, -d/16);
    vertices[66] = new Point3D(-w/4, 0, d/16);
    vertices[67] = new Point3D(w/4, 0, d/16);
    //inner top
    vertices[68] = new Point3D(w/4, -(3*h)/10, d/16);
    vertices[69] = new Point3D(w/4, -(3*h)/10, -d/16);
    vertices[70] = new Point3D(-w/4, -(3*h)/10, -d/16);
    vertices[71] = new Point3D(-w/4, -(3*h)/10, d/16);
    vertices[72] = new Point3D(w/4, -(3*h)/10, d/16);
    //top
    vertices[73] = new Point3D(w/2, -h/2, d/16);
    vertices[74] = new Point3D(w/2, -h/2, -d/16);
    vertices[75] = new Point3D(-w/2, -h/2, -d/16);
    vertices[76] = new Point3D(-w/2, -h/2, d/16);
    vertices[77] = new Point3D(w/2, -h/2, d/16);
    //back bottom
    vertices[78] = new Point3D(w/2, h/2, -d/16);
    vertices[79] = new Point3D(w/2, 0, -d/16);
    vertices[80] = new Point3D(-w/2, 0, -d/16);
    vertices[81] = new Point3D(-w/2,h/2, -d/16);
    vertices[82] = new Point3D(-w/4,h/2, -d/16);

    vertices[83] = new Point3D(-w/4, (2*h)/10, -d/16);
    vertices[84] = new Point3D(w/4, (2*h)/10, -d/16); 
    vertices[85] = new Point3D(w/4,h/2, -d/16);
    vertices[86] = new Point3D(w/2,h/2, -d/16);
    //back top
    vertices[87] = new Point3D(w/2, 0, -d/16);
    vertices[88] = new Point3D(w/2, -h/2, -d/16);
    vertices[89] = new Point3D(-w/2, -h/2 , -d/16);
    vertices[90] = new Point3D(-w/2, 0, -d/16);
    vertices[91] = new Point3D(-w/4, 0, -d/16);

    vertices[92] = new Point3D(-w/4, -(3*h)/10, -d/16);
    vertices[93] = new Point3D(w/4, -(3*h)/10, -d/16);
    vertices[94] = new Point3D(w/4, 0, -d/16);
    vertices[95] = new Point3D(w/2, 0, -d/16);

  }

  void create(color codonColor){

    fill(codonColor);

    beginShape();
    for (int i=0; i<8; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=9; i<17; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=18; i<22; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=23; i<27; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=28; i<32; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=33; i<37; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=38; i<42; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=43; i<47; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=48; i<52; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=53; i<57; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=58; i<62; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=63; i<67; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=68; i<72; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=73; i<77; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=78; i<86; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=87; i<95; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
  }

}
