class ButtonC
{
  float x, y;
  int w, h;
  //Added id
  int id;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   

  void pressed() {
    if(over && mousePressed) {
      pressed = true;
      //sets whichPressed to id.
      whichPressedC=id;
      changedC=true;
    } 
    else {
      pressed = false;
    }    
  }

  boolean overRect(float x, float y, int width, int height) {
    if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
      return true;
    } 
    else {
      return false;
    }
  }
}

class ImageButtonsC extends ButtonC
{
  PImage base;
  PImage roll;
  PImage down;
  PImage selected;
  PImage currentimage;
  //check out that there is an extra term for the id.
  ImageButtonsC(float ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown, PImage isel, int number) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;

    //set the id to number. 
    id = number;
    base = ibase;
    roll = iroll;
    down = idown;
    selected = isel;
    currentimage = base;
  }

  void update() 
  {
    over();
    pressed();
    if(pressed) {
      currentimage = down;
    
    } 
    else if (over){
      currentimage = roll;
      if(whichPressedC==id){
        currentimage=selected;
      }

    } 
    else {
      currentimage = base;
      if(whichPressedC==id){
        currentimage=selected;
      }

    }
  }

  void over() 
  {
    if( overRect(x+shelfMUypos, y+shelfMUypos, w+shelfMUypos, h+shelfMUypos) ) {
      over = true;
    } 
    else {
      over = false;
    }
  }

  void display() 
  {
    image(currentimage, x, y+shelfMUypos);
  }
}




