void varSetupAmut(){
  //START OF "VarSETUP A mutation"
  String link = "HIV1.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP A mutation"
}


void varSetupBmut(){
  //START OF "VarSETUP B mutation"
  String link = "HDV.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP B mutation"
}

void varSetupCmut(){
  //START OF "VarSETUP C mutation"
  String link = "T7.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP C mutation"
}

void varSetupDmut(){
  //START OF "VarSETUP D mutation"
  String link = "Helminthosporium.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP D mutation"
}

void varSetupEmut(){
  //START OF "VarSETUP E mutation"
  String link = "CmmV.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP E mutation"
}

void varSetupFmut(){
  //START OF "VarSETUP F mutation"
  String link = "Ebola.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP F mutation"
}

void varSetupGmut(){
  //START OF "VarSETUP G mutation"
  String link = "H5N1.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP G mutation"
}

void varSetupHmut(){
  //START OF "VarSETUP H mutation"
  String link = "TMV.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP H mutation"
}

void varSetupImut(){
  //START OF "VarSETUP I mutation"
  String link = "Measles.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP I mutation"
}

void varSetupJmut(){
  //START OF "VarSETUP J mutation"
  String link = "Rabies.txt";
  lines = loadStrings(link);
  String link2 = "code.txt";
  code = loadStrings(link2);

  if(code[0].equals ("A")){
  }
  else if(code[0].equals ("C")){
    lines[4] = "Helical";
  }
  else if(code[0].equals ("G")){
    lines[4] = "Complex";
  }
  else if(code[0].equals ("T")){
    lines[4] = "Icosahedral";
  }

  if(code[1].equals ("A")){
  }
  else if(code[1].equals ("C")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Fungi";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Plant";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Bacteria";
    }
  }
  else if(code[1].equals ("G")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Plant";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Vertebrate";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Fungi";
    }
  }
  else if(code[1].equals ("T")){
    if(lines[6].equals ("Bacteria")){
      lines[6] = "Vertebrate";
    }
    else if(lines[6].equals ("Fungi")){
      lines[6] ="Bacteria";
    }
    else if(lines[6].equals ("Plant")){
      lines[6] ="Fungi";
    }
    else if(lines[6].equals ("Vertebrate")){
      lines[6] ="Plant";
    }
  }

  if(code[2].equals ("A")){
  }
  else if(code[2].equals ("C")){
    //Point Mutation
    pointMutation();
    lines[7] = totalm;
  }
  else if(code[2].equals ("G")){
    //Deletion
    if(lines[7].length()<3000){
      deletionA();
      lines[7] = newlinesDA;
    }
    else if(lines[7].length()<9000){
      deletionB();
      lines[7] = newlinesDB;
    }
    else if(lines[7].length()<20000){
      deletionC();
      lines[7] = newlinesDC;
    }
    else if(lines[7].length()>20000){
      deletionD();
      lines[7] = newlinesDD;
    }

  }
  else if(code[2].equals ("T")){
    //Insertion
    insertion();
    lines[7] = newlines;
  }


  if(code[3].equals ("A")){
  }
  else if(code[3].equals ("C")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.15,1.3);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("G")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.3,1.5);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }
  else if(code[3].equals ("T")){
    if(lines[5].equals ("False")){
      lines[5] = "True";
      largo = random(1.5,1.7);
    }
    else if(lines[5].equals ("True")){
      lines[5] = "False";
    }
  }

  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP J mutation"
}
