void drawerJA(){

  // center in display window
  translate(width/2, height/2, -450);
  // rotate everything, including external large Shape
  rotateX(frameCount*PI/225);
  rotateY(frameCount*PI/250);
  rotateZ(frameCount*PI/275);

  //SHAPE Fill
  noFill(); 
  
  //SHAPE Stroke Color
  //Host Color
  
  //Bacteria
  if(lines[6].equals("Bacteria")){
    morphology = color(0, 180, 255, 50);
    envelopeColor = color(0, 180, 255, 25);
  }
  //Fungi
  else if(lines[6].equals("Fungi")){
    morphology = color(255, 255, 0, 50);
    envelopeColor = color(255, 255, 0, 25);
  }
  //Plants
  else if(lines[6].equals("Plant")){
    morphology = color(0, 255, 0, 50);
    envelopeColor = color(0, 255, 0, 25);
  }
  //Animals
  else if(lines[6].equals("Vertebrate")){
    morphology = color(255, 67, 67, 50);
    envelopeColor = color(255, 67, 67, 25);
  }

  stroke(morphology);
  strokeWeight(2);

  //move/rotate/create Codons
  for (int i=0; i<cubies; i++){

    pushMatrix();
    translate(x[i], y[i], z[i]);
    rotateX(frameCount*PI/xRot[i]);
    rotateY(frameCount*PI/yRot[i]);
    rotateX(frameCount*PI/zRot[i]);
    noStroke();
    if(i == 0){
      d[0].ggg();
    }
    if(i == 1){
      d[1].gga();
    }
    if(i == 2){
      d[2].ggc();
    }
    if(i == 3){
      d[3].ggt();
    }
    if(i == 4){
      d[4].gag();
    }
    if(i == 5){
      d[5].gaa();
    }
    if(i == 6){
      d[6].gac();
    }
    if(i == 7){
      d[7].gat();
    }
    if(i == 8){
      d[8].gcg();
    }
    if(i == 9){
      d[9].gcc();
    }
    if(i == 10){
      d[10].gca();
    }
    if(i == 11){
      d[11].gct();
    }
    if(i == 12){
      d[12].gtg();
    }
    if(i == 13){
      d[13].gta();
    }
    if(i == 14){
      d[14].gtc();
    }
    if(i == 15){
      d[15].gtt();
    }
    if(i == 16){
      d[16].agg();
    }
    if(i == 17){
      d[17].aga();
    }
    if(i == 18){
      d[18].agc();
    }
    if(i == 19){
      d[19].agt();
    }
    if(i == 20){
      d[20].aag();
    }
    if(i == 21){
      d[21].aaa();
    }
    if(i == 22){
      d[22].aac();
    }
    if(i == 23){
      d[23].aat();
    }
    if(i == 24){
      d[24].acg();
    }
    if(i == 25){
      d[25].aca();
    }
    if(i == 26){
      d[26].acc();
    }
    if(i == 27){
      d[27].act();
    }
    if(i == 28){
      d[28].atg();
    }
    if(i == 29){
      d[29].ata();
    }
    if(i == 30){
      d[30].atc();
    }
    if(i == 31){
      d[31].att();
    }
    if(i == 32){
      d[32].cgg();
    }
    if(i == 33){
      d[33].cga();
    }
    if(i == 34){
      d[34].cgc();
    }
    if(i == 35){
      d[35].cgt();
    }
    if(i == 36){
      d[36].cag();
    }
    if(i == 37){
      d[37].caa();
    }
    if(i == 38){
      d[38].cac();
    }
    if(i == 39){
      d[39].cat();
    }
    if(i == 40){
      d[40].ccg();
    }
    if(i == 41){
      d[41].cca();
    }
    if(i == 42){
      d[42].ccc();
    }
    if(i == 43){
      d[43].cct();
    }
    if(i == 44){
      d[44].ctg();
    }
    if(i == 45){
      d[45].cta();
    }
    if(i == 46){
      d[46].ctc();
    }
    if(i == 47){
      d[47].ctt();
    }
    if(i == 48){
      d[48].tgg();
    }
    if(i == 49){
      d[49].tga();
    }
    if(i == 50){
      d[50].tgc();
    }
    if(i == 51){
      d[51].tgt();
    }
    if(i == 52){
      d[52].tag();
    }
    if(i == 53){
      d[53].taa();
    }
    if(i == 54){
      d[54].tac();
    }
    if(i == 55){
      d[55].tat();
    }
    if(i == 56){
      d[56].tcg();
    }
    if(i == 57){
      d[57].tca();
    }
    if(i == 58){
      d[58].tcc();
    }
    if(i == 59){
      d[59].tct();
    }
    if(i == 60){
      d[60].ttg();
    }
    if(i == 61){
      d[61].tta();
    }
    if(i == 62){
      d[62].ttc();
    }
    if(i == 63){
      d[63].ttt();
    }
    x[i]+=xSpeed[i];
    y[i]+=ySpeed[i];
    z[i]+=zSpeed[i];
    popMatrix();

    // draw lines connecting codons
    //Line Color
    stroke(255, 60);
    strokeWeight(1);
    if (i< cubies-1){
      line(x[i], y[i], z[i], x[i+1], y[i+1], z[i+1]);
    }

    // check wall collisions
    if (x[i]>bounds/2 || x[i]<-bounds/2){
      xSpeed[i]*=-1;
    }
    if (y[i]>bounds/2 || y[i]<-bounds/2){
      ySpeed[i]*=-1;
    }
    if (z[i]>bounds/2 || z[i]<-bounds/2){
      zSpeed[i]*=-1;
    }
  }
}
