// Envelope code based on Esfera by David Pena. http://david.laveneno.org/.

class Envelope
{
  float radio =  pow(total, .267)*46.1;
  float z2 = random(-radio,radio);
  float phi = random(TWO_PI);
  float theta = asin(z2/radio);


    void create(color envelopeColor, float largo){
    noiseDetail(3);
      
    float off = (noise(millis() * 0.0005,sin(phi))-0.5) * 0.3;
    float offb = (noise(millis() * 0.0007,sin(z2) * 0.01)-0.5) * 0.3;

    float thetaff = theta+off;
    float phff = phi+offb;
    float x2 = radio * cos(theta) * cos(phi);
    float y2 = radio * cos(theta) * sin(phi);
    float z2 = radio * sin(theta);
    float msx= screenX(x2,y2,z2);
    float msy= screenY(x2,y2,z2);

    float xo = radio * cos(thetaff) * cos(phff);
    float yo = radio * cos(thetaff) * sin(phff);
    float zo = radio * sin(thetaff);

    float xb = xo * largo;
    float yb = yo * largo;
    float zb = zo * largo;
    
    beginShape(LINES);
    stroke(3);
    vertex(x2,y2,z2);
    stroke(envelopeColor);
    vertex(xb,yb,zb);
    endShape();
  }
}
