void varSetupA(){
  
  //START OF "VarSETUP A"

  //Load STRING/Virus
  String link = "HIV1.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();


  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP A"
}

void varSetupB(){
  
    //START OF "VarSETUP B"

  //Load STRING/Virus
  String link = "HDV.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP B"
}

void varSetupC(){
  
    //START OF "VarSETUP C"

  //Load STRING/Virus
  String link = "T7.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP C"
}

void varSetupD(){
  
    //START OF "VarSETUP D"

  //Load STRING/Virus
  String link = "Helminthosporium.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP D"
}

void varSetupE(){
  
    //START OF "VarSETUP E"

  //Load STRING/Virus
  String link = "CmmV.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP E"
}

void varSetupF(){
  
    //START OF "VarSETUP F"

  //Load STRING/Virus
  String link = "Ebola.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP F"
}

void varSetupG(){
  
    //START OF "VarSETUP G"

  //Load STRING/Virus
  String link = "H5N1.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[49]-counter[52]-counter[53]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP G"
}

void varSetupH(){
  
    //START OF "VarSETUP H"

  //Load STRING/Virus
  String link = "TMV.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[49]-counter[52]-counter[53]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP H"
}

void varSetupI(){
  
    //START OF "VarSETUP I"

  //Load STRING/Virus
  String link = "Measles.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[49]-counter[52]-counter[53]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP I"
}

void varSetupJ(){
  
    //START OF "VarSETUP J"

  //Load STRING/Virus
  String link = "Rabies.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[49]-counter[52]-counter[53]);
  AminoCalc();
  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  largo = random(1.1,1.15);
  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }
  battLevel = nxt.getBatteryLevel();
  //END OF "VarSETUP J"
}
